<template>
  <app-header>
    <button @click="$router.go(-1)">
      <v-icon color="white" aria-hidden="false"> mdi-chevron-left </v-icon>
    </button>
  </app-header>
  <div class="organisation">
    <template v-if="organisation">
      <div class="container">
        <div
          class="organisation-header"
          :style="{
            background: `url(${
              organisation.avatar
                ? organisation.avatar.url.full_size
                : require('../../assets/splash.svg')
            }) no-repeat center center`,
          }"
        >
          <div class="organisation-info">
            <h2>{{ organisation.name }}</h2>
            <p>Проведено событий: {{ events.length }}</p>
            <p>Волонтеров: {{ organisation.users_count }}</p>
          </div>
        </div>
      </div>
      <div class="organisation-actions">
        <div class="container">
          <v-btn
            color="blue"
            variant="contained-flat"
            size="large"
            @click="subscribe"
          >
            {{ organisation.is_subscriber ? "Отписаться" : "Подписаться" }}
          </v-btn>
          <v-btn color="blue" variant="outlined" size="large" @click="join">
            {{ organisation.is_member ? "Выйти" : "Вступить" }}
          </v-btn>
        </div>
      </div>
      <section>
        <div class="container">
          <h3>Описание</h3>
          <p>{{ organisation.description }}</p>
        </div>
      </section>
      <section>
        <div class="container">
          <h3>Контакты</h3>
          <p>{{ organisation.contacts }}</p>
        </div>
      </section>
      <section>
        <div class="container">
          <h3>События {{ organisation.name }}</h3>
          <div class="organisation-events">
            <event-preview
              :event="event"
              v-for="event in events"
              :key="event.id"
            />
          </div>
        </div>
      </section>
      <section>
        <div class="container" v-if="members">
          <h3>Волонтеры {{ organisation.name }}</h3>
          <div class="organisation-events">
            <volunteer-preview
              :volunteer="member"
              v-for="member in members"
              :key="member.id"
            />
          </div>
        </div>
      </section>
    </template>
    <div class="organisation-loader" v-else>
      <app-loader label="Загружаем организацию" />
    </div>
  </div>
</template>

<script>
import { mapActions } from "vuex";
import EventPreview from "@/components/EventPreview";
import AppLoader from "@/components/AppLoader";
import AppHeader from "@/components/AppHeader";
import VolunteerPreview from "@/components/VolunteerPreview";

export default {
  name: "OrganisationView",
  components: { VolunteerPreview, AppHeader, AppLoader, EventPreview },
  data() {
    return {
      organisation: "",
      events: "",
      members: "",
    };
  },

  methods: {
    ...mapActions({
      loadOrganisationInfo: "organisations/loadOrganisationInfo",
      loadOrganisationEvents: "organisations/loadOrganisationEvents",
      subscribeToOrganisation: "organisations/subscribeToOrganisation",
      unsubscribeToOrganisation: "organisations/unsubscribeToOrganisation",
      joinToOrganisation: "organisations/joinToOrganisation",
      leaveFromOrganisation: "organisations/leaveFromOrganisation",
      loadOrganisationMembers: "organisations/loadOrganisationMembers",
    }),

    subscribe() {
      if (this.organisation.is_subscriber) {
        this.unsubscribeToOrganisation(this.organisation.id).then(() => {
          this.loadOrganisationInfo(this.$route.params.id).then((response) => {
            this.organisation = response.data.data;
          });
        });
        return;
      }

      this.subscribeToOrganisation(this.organisation.id).then(() => {
        this.loadOrganisationInfo(this.$route.params.id).then((response) => {
          this.organisation = response.data.data;
        });
      });
    },
    join() {
      if (this.organisation.is_member) {
        this.leaveFromOrganisation(this.organisation.id).then(() => {
          this.loadOrganisationInfo(this.$route.params.id).then((response) => {
            this.organisation = response.data.data;
          });
        });
        return;
      }

      this.joinToOrganisation(this.organisation.id).then(() => {
        this.loadOrganisationInfo(this.$route.params.id).then((response) => {
          this.organisation = response.data.data;
        });
      });
    },
  },

  mounted() {
    this.loadOrganisationInfo(this.$route.params.id)
      .then((response) => {
        this.organisation = response.data.data;
      })
      .catch(() => {
        this.$router.push({ name: "Feed" });
      });
    this.loadOrganisationEvents(this.$route.params.id).then((response) => {
      this.events = response.data.data;
    });
    this.loadOrganisationMembers(this.$route.params.id).then((response) => {
      this.members = response.data.data;
    });
  },
};
</script>

<style scoped lang="scss">
.organisation {
  max-width: 425px;
  margin: 0 auto;
  padding: 0 0 64px;
  &-loader {
    margin: 45% 0 0;
    height: 100%;
    display: flex;
    align-items: center;
    justify-content: center;
  }
  &-header {
    width: 100%;
    height: 240px;
    background-size: cover !important;
    position: relative;
    &:after {
      content: "";
      width: 100%;
      height: 100%;
      display: block;
      background: linear-gradient(
        180deg,
        rgba(0, 0, 0, 0) 0%,
        rgba(0, 0, 0, 0.35) 100%
      );
      z-index: 2;
      left: 0;
      top: 0;
    }
  }
  &-info {
    position: absolute;
    left: $base-space * 4;
    bottom: $base-space * 6;
    color: $white;
    > h2 {
      font-weight: 600;
      font-size: 16px;
      line-height: 18px;
      margin: 0 0 ($base-space);
    }
    > p {
      font-weight: 400;
      font-size: 12px;
      line-height: 12px;
      &:not(:last-child) {
        margin: 0 0 ($base-space / 2);
      }
    }
  }
  &-actions {
    padding: ($base-space * 4) 0;
    > .container {
      display: grid;
      grid-template-columns: repeat(2, 1fr);
      grid-gap: $base-space * 4;
      > button {
        width: 100%;
      }
    }
  }
  > section {
    background: $white;
    padding: ($base-space * 4);
    margin: 0 0 ($base-space * 2);
    > .container {
      > h3 {
        font-style: normal;
        font-weight: 500;
        font-size: 14px;
        line-height: 18px;
        color: #5c5c5c;
        margin: 0 0 ($base-space * 2);
      }
      > p {
        font-style: normal;
        font-weight: 400;
        font-size: 14px;
        line-height: 18px;
        color: #5c5c5c;
      }
    }
  }
  &-events {
    width: 100%;
    display: flex;
    overflow-x: auto;
    flex-flow: row;
    grid-gap: $base-space * 2;
    &::-webkit-scrollbar {
      display: none;
    }
  }
}
</style>
